#ifndef _AGUIX_H
#define	_AGUIX_H

#include "wtypes.h"  
#include "lowlevelfunc.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

/*unsigned long White,Black;
int _lasterror;
Atom WM_delete_window;
XEvent LastEvent;
unsigned long ColBuf[256];*/
extern int _CharWidth,_CharHeight;
extern int _black;
extern int _white;
extern int argc2;
extern char **argv2;

#define RelX(gfxwin,x) calcpoint(gfxwin,0,x)
#define RelY(gfxwin,y) calcpoint(gfxwin,1,y)
#define ArcRelX(gfxwin,x) arccalcpoint(gfxwin,0,x)
#define ArcRelY(gfxwin,y) arccalcpoint(gfxwin,1,y)

#define TRUE 1
#define FALSE 0

#define MINWIDTH 320
#define MINHEIGHT 300

enum { NORMAL,HIGH };
enum { BUFFER,NOBUFFER};
enum { LV_NORMAL,LV_TOLEFT,LV_TORIGHT,LV_HBAR,LV_TOUP,LV_TODOWN,LV_VBAR};
enum { MES_WAIT,MES_GET };
enum { NON_GADGET,SHADOW_GADGET,BUTTON_GADGET,LISTVIEW_GADGET,STRING_GADGET,CHOOSE_GADGET,CLOSE_GADGET};
enum { NOERROR,NODISPLAY,NOMEM,NOWINDOW,NODRAWTO };

typedef struct _gui { struct _text *text;
                      struct _button *button;
                      struct _solidbutton *solidbutton;
                      struct _shadowbutton *shadowbutton;
                      struct _bevelbox *bevelbox;
                      struct _listview *listview;
                      struct _stringgadget *stringgadget;
                      struct _choosebutton *choosebutton;
                      struct _button *pressedbutton;
                      short buttonmode;
                      struct _shadowbutton *pressedshadowbutton; } _GUI;

typedef struct _gfxwin { Window Wnd;
                         Drawable Buffer;
                         int fg;
                         int bg;
                         int lastx;
                         int lasty;
                         int width;
                         int height;
                         int basew;
                         int baseh;
                         int bufferwidth;
                         int bufferheight;
                         void (*redrawfunc)(struct _gfxwin*);
                         _GUI GUI;
                         struct _gfxwin *prev;
                         struct _gfxwin *next;} _GfxWin;

struct _globalgui { Display *Dsp;
                    Screen *Scr;
                    Colormap CMap;
                    GC gc;
                    XFontStruct *font;
                    Atom WM_delete_window;
                    char *name;
                    char *classname;
                    _GfxWin *firstwin;
		    Window groupwin;};

typedef struct _text { int x;
                       int y;
                       int fg;
                       char *text;
                       int ID;
                       struct _text *next; } _Text;

typedef struct _solidbutton { int x;
                              int y;
                              int width;
                              int height;
                              int fg;
                              int bg;
                              char *text;
                              int data;
                              int ID;
                              struct _solidbutton *next; } _SolidButton;

typedef struct _shadowbutton { int x;
                               int y;
                               int width;
                               int height;
                               int button;
                               int data;
                               int ID;
                               struct _shadowbutton *next; } _ShadowButton;

typedef struct _choosebutton { int x;
                              int y;
                              int width;
                              int height;
                              int data;
                              int data2;
                              int ID;
                              struct _choosebutton *next; } _ChooseButton;

typedef struct _bevelbox { int x;
                           int y;
                           int width;
                           int height;
                           short status;
                           int data;
                           int ID;
                           struct _bevelbox *next; } _BevelBox;

typedef struct _listviewcontent { char *text;
                                  bool select;
                                  bool active;
                                  int fg_normal;
                                  int bg_normal;
                                  int fg_select;
                                  int bg_select;
                                  int fg_active;
                                  int bg_active;
                                  int fg_sel_act;
                                  int bg_sel_act;
                                  int data;
                                  int ID;
                                  struct _listviewcontent *next;
                                  struct _listviewcontent *prev; } _ListViewContent;

typedef struct _listview { int x;
                           int y;
                           int width;
                           int height;
                           bool hbar;
                           bool top;
                           int hbar_height;
                           int hbar_startpos;
                           bool vbar;
                           bool left;
                           int vbar_width;
                           int vbar_startpos;
                           struct _listviewcontent *first;
                           struct _listviewcontent *topcontent;
                           int (*sel_proc)(struct _listview *,_ListViewContent*);
                           int maxlength;
                           int maxlines;
                           int data;
                           int ID;
                           struct _listview *next;} _ListView;

typedef struct _stringgadget { int x;
                               int y;
                               int width;
                               int height;
                               char *string;
                               int maxchar;
                               int startpos;
                               int cursor;
                               int fg_normal;
                               int bg_normal;
                               int fg_high;
                               int bg_high;
                               int data;
                               int ID;
                               struct _stringgadget *next; } _StringGadget;

typedef struct _button { int x;
                         int y;
                         int width;
                         int height;
                         int fg_normal;
                         int bg_normal;
                         char *text_normal;
                         bool dual;
                         int fg_high;
                         int bg_high;
                         char *text_high;
                         int data;
                         int ID;
                         struct _button *next;} _Button;

typedef struct _message { int type;
                          KeySym key;
                          unsigned int keystate;
                          Window window;
                          unsigned int button;
                          int mousex,mousey;
                          int gadgettype;
                          void *gadget;
                          _ListViewContent *lv_oneselect;} _Message;

struct _color { unsigned char red;
                unsigned char green;
                unsigned char blue;
                struct _color *next; };

#define FONTBASELINE (_GlobalGUI.font->ascent)

/* Prototypen */

void _FillRectangle(_GfxWin *gfxwin,int x,int y,int width,int height,short mode);
void _FlushWin(_GfxWin *gfxwin,int x,int y,int width,int height);
void _ClearWin(_GfxWin *gfxwin);
void _DrawText(_GfxWin *gfxwin,int x,int y,char *text,short mode);
void _MoveTo(_GfxWin *gfxwin,int x,int y);
void _SetFG(_GfxWin *gfxwin,int farbe);
void _SetBG(_GfxWin *gfxwin,int farbe);
void _DrawTo(_GfxWin *gfxwin,int x,int y,short mode);
void _DrawLine(_GfxWin *gfxwin,int x1,int y1,int x2,int y2,short mode);
int calcpoint(_GfxWin *gfxwin,int ko,int a);
void _GUIDrawText(_GfxWin *gfxwin,_Text* temp1,short mode);
_Text* _CreateText(_GfxWin *gfxwin,int x,int y,int fg,char *text);
void _BeginRefresh(_GfxWin *gfxwin);
void _GUIDrawSolidButton(_GfxWin *gfxwin,_SolidButton *temp1,short mode);
_SolidButton* _CreateSolidButton(_GfxWin *gfxwin,int x,int y,int width,int height,int fg,int bg,char *text);
void _GUIDrawShadowButton(_GfxWin *gfxwin,_ShadowButton *temp1,short status,short mode);
_ShadowButton* _CreateShadowButton(_GfxWin *gfxwin,int x,int y,int width,int height,int button,int data);
void _GUIDrawBevelBox(_GfxWin *gfxwin,_BevelBox *temp1,short mode);
_BevelBox* _CreateBevelBox(_GfxWin *gfxwin,int x,int y,int width,int height,short status);
void _GUIDrawButton(_GfxWin *gfxwin,_Button *temp1,short status,short dual,short mode);
_Button* _CreateButton(_GfxWin *gfxwin,int x,int y,int width,int height,int fg_normal,int bg_normal,char *text_normal,bool dual,int fg_high,int bg_high,char *text_high,int data);
void _GUIDrawStringGadget(_GfxWin *gfxwin,_StringGadget *temp1,short status,short mode);
_StringGadget* _CreateStringGadget(_GfxWin *gfxwin,int x,int y,int width,int height,char *string,int maxchar,int fg_normal,int bg_normal,int fg_high,int bg_high,int data);
void _GUIDrawListView(_GfxWin *gfxwin,_ListView *temp1,int drawstate,short mode);
_ListView* _CreateListView(_GfxWin *gfxwin,int x,int y,int width,int height,bool hbar,bool top,int hbar_height,bool vbar,bool left,int vbar_width,int (*sel_proc)(_ListView *,_ListViewContent*),int data);
_ListViewContent *_AddListViewContent(_ListView *temp1,_ListViewContent *tempc1,char *string,int data);
void _RemoveListViewContent(_GfxWin *gfxwin,_ListView *temp1,_ListViewContent *tempc1);
_Message* wait4mess(_GfxWin *gfxwin,int mode);
void _ReplyMessage(_Message *msg);
_Message* _GetMessage(_GfxWin *gfxwin);
_Message* _WaitMessage(_GfxWin *gfxwin);
void _ReactMessage(_GfxWin *gfxwin,_Message *msg);
void _RedrawWin(_GfxWin *gfxwin);
_ShadowButton *_CheckShadowButton(_GfxWin *gfxwin,int mousex,int mousey);
_Button *_CheckButton(_GfxWin *gfxwin,int mousex,int mousey);
_ListView *_CheckListView(_GfxWin *gfxwin,int mousex,int mousey);
_StringGadget *_CheckStringGadget(_GfxWin *gfxwin,int mousex,int mousey);
void _HandleStringGadget(_GfxWin *gfxwin,_StringGadget *temp,_Message *msg);
void _HandleListView(_GfxWin *gfxwin,_ListView *temp,_Message *msg);
int _MaxDisplayH(_GfxWin *gfxwin,int width);
int _MaxDisplayV(_GfxWin *gfxwin,int height);
void _GUIDrawChooseButton(_GfxWin *gfxwin,_ChooseButton *temp1,short status,short mode);
_ChooseButton* _CreateChooseButton(_GfxWin *gfxwin,int x,int y,int width,int height,int data,int data2);
_ChooseButton *_CheckChooseButton(_GfxWin *gfxwin,int mousex,int mousey);

int _InitX(char *name,char *classname);
void _FreeX(void);
_GfxWin *_OpenWindow(_GfxWin *parent,int x,int y,int width,int height,int minw,int maxw,int basew,int minh,int maxh,int baseh,int bg,char *title,long flags,void (*redrawfunc)(struct _gfxwin*));
void _CloseWindow(_GfxWin *gfxwin);
void _FreeGUI(_GUI GUI);
int TextWidth(char *text,int count);

#endif
