/*
  Worker
  Ralf Hoffmann
  Version 1.3
*/

#include "wtypes.h"
#include "AGUI-X.h"
#include "COMS.h"
#include "CONFIG.h"
#include "file.h"
#include "progs.h"
#include "lowlevelfunc.h"
#include "normalmode.h"
#include "wconfig.h"

extern int errno;
extern struct _globalgui _GlobalGUI;
extern char *_locale[];
extern char *_localecoms[];
extern char *_localeflags[];
extern char *_localeuflags[];
extern char _UFlags[][5];
char *home;
extern int ColCnt;
extern unsigned long ColBuf[256];
extern int _black;
extern int _white;
extern int _NBH;
extern int _BBH;
_GfxWin *mainwin;
int _ButtonOffset;
_SolidButton *statebar,*clockbar;
_ListView *lv[2];
_StringGadget *path[2];
_Button *pathbutton[10],*lvb[2],*bbutton;
int _BankNumber,BBank,maxBBank;
bool filesunchecked;
time_t lasttimep;
bool ende;
extern struct _wconfig _WConfig;

int workerstat; /* 0=Init, 1=Running, 2=Quit, 3=Neustart */

struct timeval lastclick;
_ListViewContent *lastselect;
_MainStruct mainstruct;

void _ActivateLV(int nr);
void _CheckAction(_ListViewContent *lvc);

bool _CheckDoubleClick(struct timeval *tv)
{
  long x,y;
  long clicktime=400000;
  x=tv->tv_sec-lastclick.tv_sec;
  y=tv->tv_usec-lastclick.tv_usec;
  if(x==0) {
    if(y<clicktime) return TRUE;
  } else {
    if(y<0) {
      y=tv->tv_usec+1000000-lastclick.tv_usec;
      if(y<clicktime) return TRUE;
    }
  }
  return FALSE;
}

void _SaveSize(int w,int h)
{
  FILE *fp;
  char *file;
  file=(char*)_allocsafe(strlen(home)+10);
  if(file==NULL) {printf("No Memory!!!\n");return;}
  strcpy(file,home);
  strcat(file,"/lastsize");
  if((fp=fopen(file,"w"))!=NULL) {
    _FPutInt(w,fp);
    _FPutInt(h,fp);
    fclose(fp);
  }
  _freesafe(file);
}

void _ReadSize(int *w,int *h)
{
  FILE *fp;
  long error;
  char *file;
  file=(char*)_allocsafe(strlen(home)+10);
  if(file==NULL) {printf("No Memory!!!\n");return;}
  strcpy(file,home);
  strcat(file,"/lastsize");
  error=0;
  if((fp=fopen(file,"r"))!=NULL) {
    *w=_FGetInt(&error,fp);
    *h=_FGetInt(&error,fp);
    fclose(fp);
  } else {
    *w=-1;
  }
  _freesafe(file);
  if(error==0) return; else *w=-1;
}

void _UpdatePathButtons(void)
{
  struct _pathdef *path1;
  char *tstr;
  int x,y;
  path1=_WConfig.firstpath;
  for(x=0;x<_BankNumber;x++) {
    for(y=0;y<_WConfig.numybuttons;y++) {
      path1=path1->next;
    }
  }
  for(x=0;x<_WConfig.numybuttons;x++) {
    _freesafe(pathbutton[x]->text_normal);
    tstr=(char*)_allocsafe(strlen(path1->text)+1);
    strcpy(tstr,path1->text);
    pathbutton[x]->text_normal=tstr;
    pathbutton[x]->fg_normal=path1->fg;
    pathbutton[x]->bg_normal=path1->bg;
    path1=path1->next;
  }
  _RedrawWin(mainwin);
}

void RemapButtons(void)
{
  int banksize,x;
  struct _buttondef *tempb;
  _Button *button;
  char *tstr;
  
  banksize=_WConfig.numxbuttons*_WConfig.numybuttons*2;
  tempb=_WConfig.firstbutton;
  for(x=0;x<(BBank*banksize);x++) {
    tempb=tempb->next;
  }
  /* ab tempb mappen */
  button=bbutton;
  while((tempb!=NULL)&&(banksize>0)) {
    if(tempb->check!=0) {
      button->fg_normal=tempb->fg;
      button->bg_normal=tempb->bg;
      tstr=(char*)_allocsafe(strlen(tempb->text)+1);
      strcpy(tstr,tempb->text);
      _freesafe(button->text_normal);
      button->text_normal=tstr;
    } else {
      button->bg_normal=0;
      tstr=(char*)_allocsafe(1);
      tstr[0]=0;
      _freesafe(button->text_normal);
      button->text_normal=tstr;
    }
    tempb=tempb->next;
    banksize--;
    if(tempb->check!=0) {
      button->dual=TRUE;
      button->fg_high=tempb->fg;
      button->bg_high=tempb->bg;
      tstr=(char*)_allocsafe(strlen(tempb->text)+1);
      strcpy(tstr,tempb->text);
      _freesafe(button->text_high);
      button->text_high=tstr;
    } else {
      button->dual=FALSE;
      button->bg_high=0;
      tstr=(char*)_allocsafe(1);
      tstr[0]=0;
      _freesafe(button->text_high);
      button->text_high=tstr;
    }
    tempb=tempb->next;
    banksize--;
    button=button->next;
  }
}

void _ResetMainWin(_GfxWin *gfxwin)
{
  _Button *gbut;
  _ShadowButton *gshadowbut,*tshdw;
  int th,tw,tx,ty,x,y,txnext;
  int rbw;
  int w,h;
  float fa,fx,fw,fh;
  int rbh;
  w=mainwin->width;
  h=mainwin->height;
  if(mainwin!=NULL) {
    mainwin->basew=w;
    mainwin->baseh=h;
    gbut=mainwin->GUI.button;
    gshadowbut=mainwin->GUI.shadowbutton;
    tshdw=gshadowbut->next;
    statebar->width=w-(2*_BBH);
    fa=w/2;
    tw=(int)(fa+.5);
    gbut=gbut->next->next;
    gbut->width=tw;
    gbut=gbut->next;
    gbut->x=tw;
    gbut->width=w-tw;
    clockbar->y=h-_BBH;
    clockbar->width=w;
    tshdw->y=h-_BBH;
    tshdw->width=w;
    fh=_WConfig.numybuttons*_BBH;
    th=(int)(fh+.5);
    lv[0]->width=tw;
    lv[0]->height=h-3*_BBH-th-_NBH-6;
    lv[1]->x=tw;
    lv[1]->width=w-tw;
    lv[1]->height=h-3*_BBH-th-_NBH-6;
    gshadowbut->y=h-_BBH-th;
    gshadowbut->width=w/8;
    gshadowbut->height=th;
    path[0]->y=h-_BBH-th-_NBH-6;
    path[0]->width=tw;
    path[1]->x=tw;
    path[1]->y=h-_BBH-th-_NBH-6;
    path[1]->width=w-tw;
    tx=0;
    ty=h-_BBH-th;
    tw=w/8;
    rbh=_BBH;
    gbut=gbut->next;
    for(x=0;x<_WConfig.numybuttons;x++) {
      pathbutton[x]->y=ty+x*rbh;
      pathbutton[x]->width=tw;
      gbut=gbut->next;
    }
    fx=w/8;
    fw=w-w/8;
    fa=fw/_WConfig.numxbuttons;
    for(y=0;y<_WConfig.numybuttons;y++) {
      for(x=0;x<_WConfig.numxbuttons;x++) {
        tx=(int)(fx+x*fa+.5);
        txnext=(int)(fx+(x+1)*fa+.5);
        rbw=txnext-tx;
        gbut->x=tx;
        gbut->y=ty+y*rbh;
        gbut->width=rbw;
        gbut->height=rbh;
        gbut=gbut->next;
      }
    }
  }
}

void _ActivateLV(int nr)
{
  int onr,mode,omode;
  _Button *lvb;
  onr=(nr==0)?1:0;
  mode=mainstruct.lister[nr].activemode;
  omode=mainstruct.lister[onr].activemode;
  if(mainstruct._ActiveLV==nr) return;
  if(mainstruct._ActiveLV==onr) {
    if(omode>=0) {
      mainstruct.mode_info[omode].deactivate();
    } else {
      lvb=mainstruct.lister[onr].lvb;
      lvb->fg_normal=_WConfig.unsel_lvbfg;
      lvb->bg_normal=_WConfig.unsel_lvbbg;
      _GUIDrawButton(mainwin,lvb,NORMAL,FALSE,BUFFER);
      _FlushWin(mainwin,lvb->x,lvb->y,lvb->width,lvb->height);
    }
  } 
  mainstruct._ActiveLV=nr;
  if(mode>=0) mainstruct.mode_info[mode].activate();
  else {
    lvb=mainstruct.lister[nr].lvb;
    lvb->fg_normal=_WConfig.sel_lvbfg;
    lvb->bg_normal=_WConfig.sel_lvbbg;    
    _GUIDrawButton(mainwin,lvb,NORMAL,FALSE,BUFFER);
    _FlushWin(mainwin,lvb->x,lvb->y,lvb->width,lvb->height);
  }
}

void _CreateMainWin(int w,int h)
{
  struct _buttondef *button1;
  _Button *tb;
  int th,tw,tx,ty,x,y,txnext;
  int rbw;
  float fa,fx,fw,fh;
  int rbh;
  mainwin=_OpenWindow(NULL,0,0,w,h,MINWIDTH,0,w,MINHEIGHT,0,h,0,"Worker (c) Ralf Hoffmann",PMinSize,_ResetMainWin);
  if(mainwin!=NULL) {
    _CreateButton(mainwin,0,0,_BBH,_BBH,_black,_WConfig.statusbarbg,"A",FALSE,0,0,"",0);
    _CreateButton(mainwin,_BBH,0,_BBH,_BBH,_black,_WConfig.statusbarbg,"C",FALSE,0,0,"",-10);
    statebar=_CreateSolidButton(mainwin,2*_BBH,0,w-(2*_BBH),_BBH,_WConfig.statusbarfg,_WConfig.statusbarbg,_locale[12]);
    fa=w/2;
    tw=(int)(fa+.5);
    lvb[0]=_CreateButton(mainwin,0,_BBH,tw,_BBH,_WConfig.unsel_lvbfg,_WConfig.unsel_lvbbg,"",FALSE,0,0,"",1);
    lvb[1]=_CreateButton(mainwin,tw,_BBH,w-tw,_BBH,_WConfig.unsel_lvbfg,_WConfig.unsel_lvbbg,"",FALSE,0,0,"",2);
    clockbar=_CreateSolidButton(mainwin,0,h-_BBH,w,_BBH,_WConfig.clockbarfg,_WConfig.clockbarbg,"                                                               ");
    fh=_WConfig.numybuttons*_BBH;
    th=(int)(fh+.5);
    lv[0]=_CreateListView(mainwin,0,2*_BBH,tw,h-3*_BBH-th-_NBH-6,TRUE,_WConfig.lefthbar_top,_WConfig.lefthbar_height,TRUE,_WConfig.leftvbar_left,_WConfig.leftvbar_width,NULL,3);
    lv[1]=_CreateListView(mainwin,tw,2*_BBH,w-tw,h-3*_BBH-th-_NBH-6,TRUE,_WConfig.righthbar_top,_WConfig.righthbar_height,TRUE,_WConfig.rightvbar_left,_WConfig.rightvbar_width,NULL,4);
    _CreateShadowButton(mainwin,0,h-_BBH-th,w/8,th,Button3,7);
    _CreateShadowButton(mainwin,0,h-_BBH,w,_BBH,Button3,-5);
    path[0]=_CreateStringGadget(mainwin,0,h-_BBH-th-_NBH-6,tw,_NBH+6,_WConfig.ldir,4096,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,5);
    path[1]=_CreateStringGadget(mainwin,tw,h-_BBH-th-_NBH-6,w-tw,_NBH+6,_WConfig.rdir,4096,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,6);
    tx=0;
    ty=h-_BBH-th;
    tw=w/8;
    rbh=_BBH;
    for(x=0;x<_WConfig.numybuttons;x++) {
      pathbutton[x]=_CreateButton(mainwin,tx,ty+x*rbh,tw,rbh,1,0,"",FALSE,0,0,"",8+x);
    }
    _BankNumber=0;
    _UpdatePathButtons();
    fx=w/8;
    fw=w-w/8;
    fa=fw/_WConfig.numxbuttons;
    button1=_WConfig.firstbutton;
    _ButtonOffset=8+_WConfig.numybuttons;
    for(y=0;y<_WConfig.numybuttons;y++) {
      for(x=0;x<_WConfig.numxbuttons;x++) {
        tx=(int)(fx+x*fa+.5);
        txnext=(int)(fx+(x+1)*fa+.5);
        rbw=txnext-tx;
        if(button1->check==0) {
          tb=_CreateButton(mainwin,tx,ty+y*rbh,rbw,rbh,0,0,"",button1->next->check,button1->next->fg,button1->next->bg,button1->next->text,_ButtonOffset+y*_WConfig.numxbuttons+x);
        } else {
          tb=_CreateButton(mainwin,tx,ty+y*rbh,rbw,rbh,button1->fg,button1->bg,button1->text,button1->next->check,button1->next->fg,button1->next->bg,button1->next->text,_ButtonOffset+y*_WConfig.numxbuttons+x);
        }
        if((x+y)==0) bbutton=tb;
        button1=button1->next->next;
      }
    }
    BBank=0;
    _RedrawWin(mainwin);
    mainstruct.lister[0].lv=lv[0];
    mainstruct.lister[1].lv=lv[1];
    mainstruct.lister[0].path=path[0];
    mainstruct.lister[1].path=path[1];
    mainstruct.lister[0].lvb=lvb[0];
    mainstruct.lister[1].lvb=lvb[1];
    mainstruct.statebar=statebar;
  }
}

void _ShutdownMainWin(void)
{
  _CloseWindow(mainwin);
}

void _ChangePath(int entry)
{
  struct _pathdef *path1;
  int x,y;
  int nr,mode;
  path1=_WConfig.firstpath;
  for(x=0;x<_BankNumber;x++) {
    for(y=0;y<_WConfig.numybuttons;y++) {
      path1=path1->next;
    }
  }
  for(x=0;x<entry;x++) {
    path1=path1->next;
  }
  if(path1->check==1) {
    /* aktuellen Lister auf path einstellen */
    nr=mainstruct._ActiveLV;
    if(nr>=0) {
      mode=mainstruct.lister[nr].activemode;
      if(mode==-1) {
        (mainstruct.mode_info[0].on)(nr);
      } else if(mode>0) {
        (mainstruct.mode_info[mode].off)(nr);
        (mainstruct.mode_info[0].on)(nr);
      }
      _NL_SetDir(path1->path,nr);
    }
  }
}

void _UpdateTime(void)
{
  struct tm *timeptr;
#ifdef HAVE_LINUX_KERNEL_H
  struct sysinfo info;
  unsigned long freeram,freeswap;
#endif
  time_t timep;
  char *str,*buffer,buf1[1024];
  time(&timep);
  if(lasttimep<timep) {
    buffer=(char*)_allocsafe(1024);
    _freesafe(clockbar->text);
    clockbar->text=buffer;
#ifdef HAVE_LINUX_KERNEL_H
    sysinfo(&info);
    freeram=info.freeram;
    freeswap=info.freeswap;
#endif
    timeptr=localtime(&timep);
    str=asctime(timeptr);
    str[strlen(str)-1]=0;
    strcpy(buffer,str);
#ifdef HAVE_LINUX_KERNEL_H
    sprintf(buf1,"  --  %s: %ld KB  -  %s: %ld KB",_locale[105],freeram/1024,_locale[106],freeswap/1024);
    strcat(buffer,buf1);
#endif
    _GUIDrawSolidButton(mainwin,clockbar,BUFFER);
    _FlushWin(mainwin,clockbar->x,clockbar->y,clockbar->width,clockbar->height);
    lasttimep=timep;
  }
}

void _RunButton(int entry,int button)
{
  struct _buttondef *button1;
  int x,nr,mode,banksize;
  void (*prog)(int pointerinfo,void *info);

  banksize=_WConfig.numxbuttons*_WConfig.numybuttons*2;
  button1=_WConfig.firstbutton;
  for(x=0;x<(BBank*banksize);x++) {
  button1=button1->next;
  }
  for(x=0;x<entry;x++) {
    button1=button1->next->next;
  }
  if((button==Button3)&&(button1->next->check==1)) button1=button1->next;
  if(button1->check==1) {
    /* ensprechende Aktion ausfhren */
    nr=mainstruct._ActiveLV;
    if(nr<0) return;
    mode=mainstruct.lister[nr].activemode;
    if(mode<0) return;
    prog=mainstruct.mode_info[mode].prog[button1->comnr];
    if(prog!=NULL) (prog)(PISBUTTON,button1);
  }
}

void _CheckAction(_ListViewContent *lvc)
{
  int mode,nr;
  void (*prog)(_ListViewContent *);
  nr=mainstruct._ActiveLV;
  mode=mainstruct.lister[nr].activemode;
  prog=mainstruct.mode_info[mode].internprog[0];
  if(prog!=NULL) (prog)(lvc);
}

void _CheckShortkey(unsigned long key,unsigned int keystate)
{
  struct _buttondef *button1,*foundb;
  struct _pathdef *path1,*foundp;
  struct _hotkeydef *hotkey1,*foundhk;
  void (*prog)(int pointerinfo,void *info);
  int mode,nr,mods;
  button1=_WConfig.firstbutton;
  path1=_WConfig.firstpath;
  hotkey1=_WConfig.firsthotkey;
  foundb=NULL;
  foundp=NULL;
  foundhk=NULL;
  mods=KEYSTATEMASK(keystate);
  while((button1!=NULL)&&(foundb==NULL)) {
    if((button1->shortkey==key)&&(KEYSTATEMASK(button1->mods)==mods)&&(button1->check==1)) foundb=button1;
    button1=button1->next;
  }
  if(foundb==NULL) {
    while((path1!=NULL)&&(foundp==NULL)) {
      if((path1->shortkey==key)&&(KEYSTATEMASK(path1->mods)==mods)&&(path1->check==1)) foundp=path1;
      path1=path1->next;
    }
    if(foundp==NULL) {
      while((hotkey1!=NULL)&&(foundhk==NULL)) {
        if((hotkey1->shortkey==key)&&(KEYSTATEMASK(hotkey1->mods)==mods)) foundhk=hotkey1;
        hotkey1=hotkey1->next;
      }
    }
  }
  nr=mainstruct._ActiveLV;
  if(nr<0) return;
  mode=mainstruct.lister[nr].activemode;
  if(mode<0) return;
  if(foundb!=NULL) {
    prog=mainstruct.mode_info[mode].prog[foundb->comnr];
    if(prog!=NULL) (prog)(PISBUTTON,foundb);
  } else if(foundp!=NULL) {
    if(foundp->check==1) {
      /* aktuellen Lister auf path einstellen */
      if(mode==-1) {
        (mainstruct.mode_info[0].on)(nr);
      } else if(mode>0) {
        (mainstruct.mode_info[mode].off)(nr);
        (mainstruct.mode_info[0].on)(nr);
      }
      _NL_SetDir(foundp->path,nr);
    }
  } else if(foundhk!=NULL) {
    prog=mainstruct.mode_info[mode].prog[foundhk->comnr];
    if(prog!=NULL) (prog)(PISHOTKEY,foundhk);
  }
}

void _MainLoop(void)
{
  _Message *msg;
  _Button *tbutton;
  _ShadowButton *tsbutton;
  _ListViewContent *report;
  _ListView *reportlv;
  _StringGadget *reportsg;
  int maxbanks,waitcount;
  struct _pathdef *path1;
  struct _buttondef *tempb;
  int x;
  int nr,mode;
  struct timespec waittime;
  struct timeval tv;
  char *newpath;
  bool update;
  _RealLister *rl;
  _IMInfo *imi;
  _FileEntry *lastactive;
  XEvent E;

  path1=_WConfig.firstpath;
  x=0;
  while(path1!=NULL) {
    x++;
    path1=path1->next;
  }
  maxbanks=x/_WConfig.numybuttons;

  tempb=_WConfig.firstbutton;
  x=0;
  while(tempb!=NULL) {
    x++;
    tempb=tempb->next;
  }
  maxBBank=x/(_WConfig.numybuttons*_WConfig.numxbuttons*2);

  waittime.tv_sec=0;
  waittime.tv_nsec=20*1000000;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  imi=(_IMInfo*)mainstruct.mode_info[1].special_info;
  ende=FALSE;
  lastactive=NULL;
  update=FALSE;
  waitcount=0;

  for(;;) {
    if((msg=_GetMessage(mainwin))!=NULL) {
      update=TRUE;
      if(msg->type==ButtonRelease) {
        if(msg->gadgettype==BUTTON_GADGET) {
          tbutton=(_Button*)msg->gadget;
          if(tbutton->data==0) {
            _About();
          } else if (tbutton->data==-10) {
            if(ChangeWorkerConfig()==1) workerstat=3;
          } else if((tbutton->data>=1)&&(tbutton->data<3)) {
            if(msg->button==Button1) {
              _ActivateLV(tbutton->data-1);
            } else if(msg->button==Button3) {
              /* Einstellungen fr LV tbutton->data-1 aufrufen */
              _ChangeListerSets(tbutton->data-1);
            }
          } else if((tbutton->data>7)&&(tbutton->data<(8+_WConfig.numybuttons))) {
            x=tbutton->data-8;
            _ChangePath(x);
          } else if(tbutton->data>=_ButtonOffset) {
            x=tbutton->data-_ButtonOffset;
            /* ToDo: jeweilige Aktion ausfhren (_RunButton(x,msg->button)) */
            _RunButton(x,msg->button);
          }
        } else if(msg->gadgettype==SHADOW_GADGET) {
          tsbutton=(_ShadowButton*)msg->gadget;
          if(tsbutton->data==-5) {
            if((BBank+1)==maxBBank) {
              BBank=0;
            } else {
              BBank++;
            }
            RemapButtons();
            _RedrawWin(mainwin);
          } else {
            _BankNumber++;
            if(_BankNumber==maxbanks) _BankNumber=0;
            _UpdatePathButtons();
          }
        }
      } else if(msg->type==KeyRelease) {
      } else if(msg->type==KeyPress) {
        switch(msg->key) {
          case XK_Tab:nr=mainstruct._ActiveLV;
                      _ActivateLV((nr==0)?1:0);
                      break;
          default:/* Shortkey prfen */
                  _CheckShortkey(msg->key,msg->keystate);
                  break;
        }
        /* TODO: hier vielleicht die restlichen Messages abholen */
        while(XCheckMaskEvent(_GlobalGUI.Dsp,KeyPressMask,&E));
/*        while((tmsg=_GetMessage(mainwin))!=NULL) {
          _ReplyMessage(tmsg);
        }*/
      } else if(msg->type==ButtonPress) {
        if(msg->gadgettype==STRING_GADGET) {
          reportsg=(_StringGadget*)msg->gadget;
          nr=reportsg->data-5;

          newpath=(char*)_allocsafe(strlen(reportsg->string)+1);
          strcpy(newpath,reportsg->string);
          mode=mainstruct.lister[nr].activemode;
          if(mode==-1) {
            (mainstruct.mode_info[0].on)(nr);
          } else if(mode>0) {
            (mainstruct.mode_info[mode].off)(nr);
            (mainstruct.mode_info[0].on)(nr);
          }
          _NL_SetDir(newpath,nr);
          _freesafe(newpath);
          _ActivateLV(nr);
        } else if(msg->gadgettype==LISTVIEW_GADGET) {
          reportlv=(_ListView*)msg->gadget;
          report=msg->lv_oneselect;
          _ActivateLV(reportlv->data-3);
          if(report!=NULL) {
            gettimeofday(&tv,NULL);
            if(_CheckDoubleClick(&tv)==TRUE) {
              if(report==lastselect) {
                _CheckAction(report);
              }
            }
            lastclick.tv_sec=tv.tv_sec;
            lastclick.tv_usec=tv.tv_usec;
            lastselect=report;
          }
        }
      } else if(msg->type==ClientMessage) {
        if(msg->gadgettype==CLOSE_GADGET) {
          if(msg->window==mainwin->Wnd) {
            _QuitOp(PISNOTHING,NULL);
          }
        }
      }
      _ReplyMessage(msg);
    } else {
      _UpdateTime();
      /* ToDo: Hier Abhngigkeiten von Moden eintragen (z.B. Im rechten Lister den Inhalt
               der angewhlten Datei vom linken Lister anzeigen) */
      if(waitcount>1) {
        waitcount=0;
        if((mainstruct.lister[0].activemode==1)||(mainstruct.lister[1].activemode==1)) {
          /* einer der beiden Lister ist auf Modus 1, daher entsprechende Routionen hier
             checken */
          if(mainstruct.lister[0].activemode==0) x=0;
          else if(mainstruct.lister[1].activemode==0) x=1;
          else x=-1;
          if(x>=0) {
            _IM_ShowInfo(rl->activefe[x]);
          } else {
            _IM_ShowInfo(NULL);
          }
        }
        _NL_CheckNextFile();
      } else waitcount++;
      nanosleep(&waittime,NULL);
      update=FALSE;
    }
/*    if(ende==TRUE) break;*/
    if(ende==TRUE) workerstat=2;
    if(workerstat!=1) break;
  }
}

struct old_values { char *ldir;
                    char *rdir; };

int main(int argc,char *argv[])
{
  FILE *fr;
  DIR *dir;
  char *file,*configfile,*buffer;
  struct _color *tcol1,*tcol2;
  struct _buttondef *tempb,*tempb1;
  struct _pathdef *tempp,*tempp1;
  struct _filetypedef *tempft,*tempft1;
  int w,h,mode,i;
  struct old_values oldv;
  void (*proc)(int); 
  _RealLister *rl;
  bool showversion,showhelp;

  showversion=FALSE;
  showhelp=FALSE;
  for(i=1;i<argc;i++) {
    if((strcmp(argv[i],"-V")==0)||(strcmp(argv[i],"--version")==0)) {
      showversion=TRUE;
    } else if((strcmp(argv[i],"-help")==0)||(strcmp(argv[i],"--help")==0)) {
      showhelp=TRUE;
    } else showhelp=TRUE;
  }
  if(showversion==TRUE) {
    printf("Worker Version: %d.%d.%d\n",MAJOR,MINOR,PATCH);
    exit(0);
  }
  if(showhelp==TRUE) {
    printf("Worker Filemanager\n");
    printf("  Version: %d.%d.%d\n",MAJOR,MINOR,PATCH);
    printf("  Using: -V --version: Print the program version and exit\n");
    printf("         -help --help: Print this help and exit\n");
    exit(0);
  }

#ifdef USE_MEM_SYSTEM
  _memsysteminit();
#endif
  workerstat=0;
  
  argc2=argc;
  argv2=argv;
  
  file=(char*)getenv("HOME");
  if(file==NULL) {
    printf("There is no HOME-Variable, please set it to your home-directory!\n");
    return 0;
  }
  home=(char*)_allocsafe(strlen(file)+1+8);
  strcpy(home,file);
  strcat(home,"/.worker");
  do {
    if(workerstat==0) {
      /* das hier nur ausfhren, wenn wir das erste Mal starten */
      dir=opendir(home);
      if(dir==NULL) {
        printf("\nIt seems, that Worker isn't fully installed\n");
        printf("Will use the standard configuration with english as language,\n");
        printf("but it's better to install it OR:\n");
        printf("  Click on the second button at the top bar of worker\n");
        printf("  Save the configuration\n");
        printf("  If you want an other language:\n");
        printf("    Create the directory \"~/.worker/catalogs\"\n");
        printf("    Copy the language you want in this dir (4 files)\n");
        printf("    Start the configurator and choose your language and save again\n");
        printf("  That's all, but let say me again: ReInstall it!\n");
        printf("    It does the same but it's easier for you ;-)\n\n");
      } else closedir(dir);
    }
    configfile=(char*)_allocsafe(strlen(home)+8);
    strcpy(configfile,home);
    strcat(configfile,"/config");
    if((fr=fopen(configfile,"r"))==NULL) {
      if(_SetDefaultConfig()!=0) {
        printf("Error while creating Default-Configuration.\n");
        return 0;
      }
    } else {
      if(_ReadConfig(fr)!=0) {
        tcol1=_WConfig.first;
        _WConfig.first=NULL;
        tempb=_WConfig.firstbutton;
        _WConfig.firstbutton=NULL;
        tempp=_WConfig.firstpath;
        _WConfig.firstpath=NULL;
        tempft=_WConfig.firsttype;
        _WConfig.firsttype=NULL;
        while(tcol1!=NULL) {
          tcol2=tcol1->next;
          _FreeCColor(tcol1);
          tcol1=tcol2;
        }
        while(tempb!=NULL) {
          tempb1=tempb->next;
          _FreeConfigButton(tempb);
          tempb=tempb1;
        }
        while(tempp!=NULL) {
          tempp1=tempp->next;
          _FreeConfigPath(tempp);
          tempp=tempp1;
        }
        while(tempft!=NULL) {
          tempft1=tempft->next;
          _FreeFiletype(tempft);
          tempft=tempft1;
        }
        if(_SetDefaultConfig()!=0) {
          printf("Error while creating Default-Configuration.\n");
          fclose(fr);
          return 0;
        }
      }
      fclose(fr);
    }
    _freesafe(configfile);
    _CreateLanguage();
    _ReadSize(&w,&h);
    if(w==-1) {
      w=640;
      h=480;
    }
    /*vvv Init-Prozess vvv*/
    if(_InitX("worker","Worker")==NOERROR) {
      _InitWorker();
      _CreateMainWin(w,h);
      /* Lister x auf mainstruct.loadsets.activemode[x] schalten */
      mode=mainstruct.loadsets.activemode[0];
      if(mode>=0) {
        proc=mainstruct.mode_info[mode].on;
        (proc)(0);
      }
      mode=mainstruct.loadsets.activemode[1];
      if(mode>=0) {
        proc=mainstruct.mode_info[mode].on;
        (proc)(1);
      }
      /* Wenn Startpfad vorhanden und jeweiliger Lister auf Mode 0, dann Verzeichnis lesen */
      if((strlen(_WConfig.ldir)>0)&&(workerstat!=3)) {
        if(mainstruct.lister[0].activemode<1) {
          if(mainstruct.lister[0].activemode==-1) (mainstruct.mode_info[0].on)(0);
          chdir(_WConfig.ldir);
          buffer=getcwd(NULL,4096);
          _NL_SetDir(buffer,0);
          free(buffer); /* der Speicher kommt nicht von _allosafe */
        }
      } else if(workerstat==3) {
        if(mainstruct.lister[0].activemode==0) {
          if(oldv.ldir!=NULL) {
            _NL_SetDir(oldv.ldir,0);
            _freesafe(oldv.ldir);
            oldv.ldir=NULL;
          }
        }
      }
      if((strlen(_WConfig.rdir)>0)&&(workerstat!=3)) {
        if(mainstruct.lister[1].activemode<1) {
          if(mainstruct.lister[1].activemode==-1) (mainstruct.mode_info[0].on)(1);
          chdir(_WConfig.rdir);
          buffer=getcwd(NULL,4096);
          _NL_SetDir(buffer,1);
          free(buffer);
        }
      } else if(workerstat==3) {
        if(mainstruct.lister[1].activemode==0) {
          if(oldv.rdir!=NULL) {
            _NL_SetDir(oldv.rdir,1);
            _freesafe(oldv.rdir);
            oldv.rdir=NULL;
          }
        }
      }
      /* mainstruct.loadsets._ActiveLV activieren */
      if(mainstruct.loadsets._ActiveLV>=0) {
        _ActivateLV(mainstruct.loadsets._ActiveLV);
      }
      /*^^^ Ende Init-Prozess ^^^*/
      if(mainwin!=NULL) {
        _Check4Filters();
        workerstat=1;
        _MainLoop();
        if(workerstat==3) {
          oldv.ldir=NULL;
          if(mainstruct.lister[0].activemode==0) {
            rl=mainstruct.mode_info[0].special_info;
            if(rl->Dir[0]!=NULL) oldv.ldir=dupstring(rl->Dir[0]);
          }
          oldv.rdir=NULL;
          if(mainstruct.lister[1].activemode==0) {
            rl=mainstruct.mode_info[0].special_info;
            if(rl->Dir[1]!=NULL) oldv.rdir=dupstring(rl->Dir[1]);
          }
        }
        w=mainwin->width;
        h=mainwin->height;
        _ShutdownMainWin();
        _SaveSize(w,h);
        _SaveListerSettings();
      }
      _ShutdownWorker();
    }
    _FreeLanguage();
    _FreeConfig();
    _FreeX();
  } while(workerstat!=2);
  _freesafe(home);
#ifdef USE_MEM_SYSTEM
  _memsystemcheck();
#endif
  return 0;
}

